package PhotoPub::Images;
require Exporter;
@ISA = qw(Exporter);
@EXPORT_OK = qw(&picfile &picrange &canonicalname);

use strict;
no strict 'vars'; # until we break the recursive Config<->Images dependency

use PhotoPub::Global qw(&$error);
use PhotoPub::Config qw($defaultpath);
use PhotoPub::Handlers qw(&handlephoto &listhandlephoto);

sub picrange {
  my ($rangestr)=@_;
  my @photos=();
  my $curpath=$defaultpath;
  foreach (split(/,/,$rangestr)) {
    if(/^((?:.*\/)?)(\d+)\-(\d+)$/) {
      my $path=$1;
      $path=$curpath.$path if substr($path,0,1) ne '/' && defined $curpath;
      foreach my $num ($2..$3) {
	my $photo=$path.$num;
	push @photos,$photo if defined &picfile($photo);
      }
      $curpath=$path;
    } elsif(/^((?:.*\/)?)(\d+)$/) {
      my $path=$1;
      $path=$curpath.$path if substr($path,0,1) ne '/' && defined $curpath;
      my $photo=$path.$2;
      push @photos,$photo if defined &picfile($photo);
      $curpath=$path;
    } elsif(/^((?:.*\/)?)\*$/) {
      my $path=$1;
      $path=$curpath.$path if substr($path,0,1) ne '/' && defined $curpath;
      foreach my $num (sort { $a <=> $b } 
		       @{listhandlephoto('photolist',$path)}) {
	my $photo=$path.$num;
	push @photos,$photo if defined &picfile($photo);
      }
      $curpath=$path;
    }
  }
  return @photos;
}

sub picfile {
  my ($photo)=@_;
  return handlephoto('imagefile',$photo);
}

sub canonicalname {
  my ($photo)=@_;
  my $canonicalphoto=&handlephoto('canonicalname',$photo);
  $canonicalphoto=$photo unless defined $canonicalphoto;
  return $canonicalphoto;
}

1;
